#!/usr/local/bin/perl
######################################################################
# X֔ԍEZCGI Ver2.1
# iCGI{́j
# Copyright(C) futomi 2001 - 2002
# http://www.futomi.com/
######################################################################


######################################################################
# main
######################################################################
BEGIN {
	eval "use GDBM_File";
	if($@) {
		print "Content-Type: text/html; charset=Shift_JIS\n\n";
		print "GDBM_File T[oɎĂȂ߁ACGI͂p܂B<br>$@\n";
		exit;
	}
}

use strict;
use Fcntl;
use CGI;
my $q = new CGI;
require './config.cgi';
require './jcode.pl';

my $TEMP_DIR = &config::TEMP_DIR;
my $RESULT_TEMP = &config::RESULT_TEMP;
my $ERROR_TEMP = &config::ERROR_TEMP;
my $ZENKAKU_FLAG = &config::ZENKAKU_FLAG;
my @ALLOW_FORM_URLS = &config::ALLOW_FORM_URLS;
my $NO_HIT_FLAG = &config::NO_HIT_FLAG;


my %PrefCodeTable = (
	'01'	=>	'kC,zbJChE',
	'02'	=>	'X,AIP',
	'03'	=>	'茧,CeP',
	'04'	=>	'{錧,~MP',
	'05'	=>	'Hc,AL^P',
	'06'	=>	'R`,}K^P',
	'07'	=>	',tNV}P',
	'08'	=>	'錧,CoLP',
	'09'	=>	'Ȗ،,g`MP',
	'10'	=>	'Qn,O}P',
	'11'	=>	'ʌ,TC^}P',
	'12'	=>	't,`oP',
	'13'	=>	's,gELEg',
	'14'	=>	'_ސ쌧,JiKP',
	'15'	=>	'V,jCK^P',
	'16'	=>	'xR,g}P',
	'17'	=>	'ΐ쌧,CVJP',
	'18'	=>	'䌧,tNCP',
	'19'	=>	'R,}iVP',
	'20'	=>	'쌧,iKmP',
	'21'	=>	'򕌌,MtP',
	'22'	=>	'É,VYIJP',
	'23'	=>	'm,AC`P',
	'24'	=>	'Od,~GP',
	'25'	=>	'ꌧ,VKP',
	'26'	=>	's{,LEgt',
	'27'	=>	'{,IITJt',
	'28'	=>	'Ɍ,qESP',
	'29'	=>	'ޗǌ,iP',
	'30'	=>	'a̎R,J}P',
	'31'	=>	'挧,gbgP',
	'32'	=>	',V}lP',
	'33'	=>	'R,IJ}P',
	'34'	=>	'L,qV}P',
	'35'	=>	'R,}O`P',
	'36'	=>	',gNV}P',
	'37'	=>	'쌧,JKP',
	'38'	=>	'Q,GqP',
	'39'	=>	'm,RE`P',
	'40'	=>	',tNIJP',
	'41'	=>	'ꌧ,TKP',
	'42'	=>	'茧,iKTLP',
	'43'	=>	'F{,N}gP',
	'44'	=>	'啪,IIC^P',
	'45'	=>	'{茧,~ULP',
	'46'	=>	',JSV}P',
	'47'	=>	'ꌧ,ILiP'
);


# OT[o̗p֎~
&ExternalRequestCheck;


# ev[gt@C̓
my $TmpFile = $q->param('template');
if($TmpFile) {
	$RESULT_TEMP = $TmpFile;
}


# L[̗X֔ԍ擾
my $PostalCode = $q->param('postalcode');
unless($PostalCode) {
	&ErrorPrint ("X֔ԍw肵ĉB");
}

# ͗X֔ԍSppϊA͒l`FbN
$PostalCode = &CheckPostal($PostalCode);

# caZf[^
my $CodeLength = length($PostalCode);
my %PostalCodeTable;
tie(%PostalCodeTable, "GDBM_File", "./postalcode.gdbm", O_RDONLY, 0606)
	or &ErrorPrint("f[^x[Xt@C ./postalcode.gdbm I[vł܂łB: $!");
my $Result = $PostalCodeTable{$PostalCode};
untie %PostalCodeTable;

unless($Result) {
	if($NO_HIT_FLAG) {
		&ErrorPrint("Y̗X֔ԍ݂͑܂B: [$PostalCode]");
	}
}

# pJîcaf[^SpJiɕϊ
&jcode::h2z_sjis(\$Result);
# ʂo
&PrintResult($Result);

exit;



######################################################################
# sub routine
######################################################################


sub CheckPostal {
	my($PostalCode) = @_;
	unless($PostalCode) {&ErrorPrint("X֔ԍw肵ĉB");}
	my %RmChrs = (
		'O'=>'0', 'P'=>'1', 'Q'=>'2', 'R'=>'3', 'S'=>'4', 'T'=>'5',
		'U'=>'6', 'V'=>'7', 'W'=>'8', 'X'=>'9', '['=>'', '|'=>'',
		''=>'', '-'=>''
	);
	&jcode::convert(\$PostalCode, "euc", "sjis");
	my($RmChr, $RmChrEuc);
	for $RmChr (keys %RmChrs) {
		$RmChrEuc = $RmChr;
		&jcode::convert(\$RmChrEuc, "euc", "sjis");
		$PostalCode =~ s/$RmChrEuc/$RmChrs{$RmChr}/g;
	}
	if($PostalCode =~ /[^0-9]/) {
		&ErrorPrint("X֔ԍɔpȊO̕܂܂Ă܂B: <tt>[$PostalCode]</tt>");
	}
	unless(length($PostalCode) == 7) {
		&ErrorPrint("X֔ԍ 7Ŏw肵ĉB: <tt>[$PostalCode]</tt>");
	}
	return $PostalCode;
}


sub PrintResult {
	my($ResultStr) = @_;
	my %LocalCodeTable;
	my($LocalCode, $Town, $TownKana, $Org, $OrgKana) = split(/,/, $ResultStr);
	my($Pref, $PrefKana) = split(/,/, $PrefCodeTable{substr($LocalCode, 0, 2)});
	tie %LocalCodeTable, "GDBM_File", "./localcode.gdbm", O_RDONLY, 0606
		or &ErrorPrint("f[^x[Xt@C ./localcode.gdbm I[vł܂łB: $!");
	my($City, $CityKana) = split(/,/, $LocalCodeTable{$LocalCode});
	untie %LocalCodeTable;
	&jcode::h2z_sjis(\$CityKana);
	my $PostalCode1 = substr($PostalCode, 0, 3);
	my $PostalCode2 = substr($PostalCode, 3, 4);
	if($ZENKAKU_FLAG) {
		$PostalCode1 = &NumHan2Zen($PostalCode1);
		$PostalCode2 = &NumHan2Zen($PostalCode2);
	}

	my $file = "$TEMP_DIR/$RESULT_TEMP";
	my $size = -s $file;
	if(!open(TEMP, "$file")) {
		&ErrorPrint("ev[gt@C <tt>$file</tt> I[vł܂łB : $!");
	}
	binmode(TEMP);
	my $FileStr;
	sysread(TEMP, $FileStr, $size);
	close(TEMP);
	$FileStr =~ s/\$POSTALCODE1\$/$PostalCode1/g;
	$FileStr =~ s/\$POSTALCODE2\$/$PostalCode2/g;
	$FileStr =~ s/\$PREF\$/$Pref/g;
	$FileStr =~ s/\$CITY\$/$City/g;
	$FileStr =~ s/\$TOWN\$/$Town/g;
	$FileStr =~ s/\$PREFKANA\$/$PrefKana/g;
	$FileStr =~ s/\$CITYKANA\$/$CityKana/g;
	$FileStr =~ s/\$TOWNKANA\$/$TownKana/g;
	$FileStr =~ s/\$ORG\$/$Org/g;
	$FileStr =~ s/\$ORGKANA\$/$OrgKana/g;
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print "$FileStr\n";
	exit;
}


sub NumHan2Zen {
	my($InNum) = @_;
	my %NumTable = (
		'0'=>'O', '1'=>'P', '2'=>'Q', '3'=>'R', '4'=>'S',
		'5'=>'T', '6'=>'U', '7'=>'V', '8'=>'W', '9'=>'X'
	);
	my $num;
	for $num (keys %NumTable) {
		$InNum =~ s/$num/$NumTable{$num}/g;
	}
	return $InNum;
}


sub ExternalRequestCheck {
	my $url;
	if(scalar @ALLOW_FORM_URLS) {
		my $flag = 0;
		for $url (@ALLOW_FORM_URLS) {
			if($ENV{'HTTP_REFERER'} =~ /^$url/) {
				$flag = 1;
			}
		}
		unless($flag) {
			&ErrorPrint("sȃT[õNGXgłB");
		}
	}
}


sub ErrorPrint {
	my($msg) = @_;
	my $file = "$TEMP_DIR/$ERROR_TEMP";
	my $size = -s $file;
	if(!open(FILE, "$file")) {
		&ErrorPrint2("ev[gt@C <tt>$file</tt> I[vł܂łB : $!");
	}
	binmode(FILE);
	my $str;
	sysread(FILE, $str, $size);
	close(FILE);
	$str =~ s/\$ERROR\$/$msg/g;
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print "$str\n";
	exit;
}

sub ErrorPrint2 {
	my($msg) = @_;
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print "$msg\n";
	exit;
}

